#include "CameraComponent.h"

CameraComponent::CameraComponent(Object* owner)
    : Component(owner) {}

void CameraComponent::Save(YAML::Emitter& out) {
    out << YAML::BeginMap;
    out << YAML::Key << "type" << YAML::Value << "CameraComponent";
    out << YAML::Key << "zoom" << YAML::Value << zoom;
    out << YAML::Key << "aspectRatio" << YAML::Value << aspectRatio;
    out << YAML::Key << "fov" << YAML::Value << fov;
    out << YAML::EndMap;
}

void CameraComponent::Load(const YAML::Node& node) {
    zoom = node["zoom"] ? node["zoom"].as<float>() : 1.0f;
    aspectRatio = node["aspectRatio"] ? node["aspectRatio"].as<float>() : 16.0f / 9.0f;
    fov = node["fov"] ? node["fov"].as<float>() : 45.0f;
}
