#pragma once
#include "Component.h"
#include <glm/glm.hpp>
#include <yaml-cpp/yaml.h>

class CameraComponent : public Component {
public:
    float zoom = 1.0f;
    float aspectRatio = 16.0f / 9.0f;
    float fov = 45.0f;

    CameraComponent(Object* owner);

    void Save(YAML::Emitter& out) override;
    void Load(const YAML::Node& node) override;

    float GetZoom() const { return zoom; }
    float GetAspectRatio() const { return aspectRatio; }
    float GetFOV() const { return fov; }

    void SetZoom(float z) { zoom = z; }
    void SetAspectRatio(float a) { aspectRatio = a; }
    void SetFOV(float f) { fov = f; }
};
