#pragma once
#include <GL/glew.h>
#include <glm/glm.hpp>

class SpriteComponent;

class Renderer {
public:
    static void Init();
    static void Resize(int w, int h);
    static void Begin();
    static void End();
    static void DrawSprite(SpriteComponent* sprite, const glm::vec2& pos);
    static GLuint GetRenderTexture();
    static glm::ivec2 GetSize();

private:
    static GLuint fbo, textureColorBuffer, rbo;
    static int width, height;

    static GLuint shader, quadVAO, quadVBO;
    static void InitQuad();
    static GLuint LoadShader(const char* vertexSrc, const char* fragmentSrc);
};
